class initialiseable_array:
  def __init__(self,n,val=0.0):
    self.n=n # The size of the array
    self.size=0 # Number of currently written-to positions.
    self.init_value=val # The value that the array will be initialised to.
    # We define several (non-initialised) helper arrays.
    # According to the usual assumptions, reading from non-initialised
    # positions results in unpredictable values, so we just use here some
    # arbitrary numbers to simulate this.
    self.data=[234.5]*n
    self.list=[6]*n
    self.backref=[789]*n
  def initialise_array(self):
    self.size=0
  def is_written_to(self,pos): # Checks if a position had been written to.
    hint=self.backref[pos] # The usual assumptions don't require us to do
                           # any bounds checking, so we don't.
    if hint<0 or hint>=self.size:
      return False
    return self.list[hint]==pos
  def get_value(self,pos):
    if self.is_written_to(pos):
      return self.data[pos]
    else:
      return self.init_value
  def set_value(self,pos,val):
    self.data[pos]=val
    if not self.is_written_to(pos):
      self.backref[pos]=self.size
      self.list[self.size]=pos
      self.size+=1
 
